Index: /palm/trunk/SOURCE/surface_layer_fluxes_mod.f90
===================================================================
--- /palm/trunk/SOURCE/surface_layer_fluxes_mod.f90	(revision 3667)
+++ /palm/trunk/SOURCE/surface_layer_fluxes_mod.f90	(revision 3668)
@@ -1299,272 +1049,144 @@
                          ( surf%uvw_abs(m)**3 * surf%vpt1(m) * kappa**2        &
                            + 1.0E-20_wp )
-                ENDDO
+             ENDDO
+          ELSE
+             !$OMP PARALLEL DO PRIVATE( k, z_mo )
+             !$ACC PARALLEL LOOP PRIVATE(k, z_mo) &
+             !$ACC PRESENT(surf, drho_air_zw)
+             DO  m = 1, surf%ns
+
+                k   = surf%k(m)
+
+                z_mo = surf%z_mo(m)
+
+                surf%rib(m) = - g * z_mo * surf%shf(m) *                    &
+                                     drho_air_zw(k-1)            /          &
+                        ( surf%uvw_abs(m)**3 * surf%pt1(m) * kappa**2       &
+                        + 1.0E-20_wp )
+             ENDDO
+          ENDIF
+       ENDIF
+
+!
+!--    Calculate the Obukhov length using Newton iteration
+       !$ACC PARALLEL LOOP PRIVATE(i, j, z_mo) &
+       !$ACC PRIVATE(ol_old, ol_m, ol_l, ol_u, f, f_d_ol) &
+       !$ACC PRESENT(surf)
+       DO  m = 1, surf%ns
+
+          i   = surf%i(m)            
+          j   = surf%j(m)
+
+          z_mo = surf%z_mo(m)
+
+!
+!--       Store current value in case the Newton iteration fails
+          ol_old = surf%ol(m)
+
+!
+!--       Ensure that the bulk Richardson number and the Obukhov 
+!--       length have the same sign
+          IF ( surf%rib(m) * surf%ol(m) < 0.0_wp  .OR.                      &
+               ABS( surf%ol(m) ) == ol_max )  THEN
+             IF ( surf%rib(m) > 1.0_wp ) surf%ol(m) =  0.01_wp
+             IF ( surf%rib(m) < 0.0_wp ) surf%ol(m) = -0.01_wp
+          ENDIF
+!
+!--       Iteration to find Obukhov length
+          iter = 0
+          DO
+             iter = iter + 1
+!
+!--          In case of divergence, use the value of the previous time step
+             IF ( iter > 1000 )  THEN
+                surf%ol(m) = ol_old
+                EXIT
+             ENDIF
+
+             ol_m = surf%ol(m)
+             ol_l = ol_m - 0.001_wp * ol_m
+             ol_u = ol_m + 0.001_wp * ol_m
+
+
+             IF ( ibc_pt_b /= 1 )  THEN
+!
+!--             Calculate f = Ri - [...]/[...]^2 = 0
+                f = surf%rib(m) - ( z_mo / ol_m ) * (                          &
+                                              LOG( z_mo / surf%z0h(m) )        &
+                                              - psi_h( z_mo / ol_m )           &
+                                              + psi_h( surf%z0h(m) /           &
+                                                       ol_m )                  &  
+                                                     )                         &
+                                           / ( LOG( z_mo / surf%z0(m) )        &
+                                              - psi_m( z_mo / ol_m )           &
+                                              + psi_m( surf%z0(m) /  ol_m )    &
+                                                 )**2
+
+!
+!--              Calculate df/dL
+                 f_d_ol = ( - ( z_mo / ol_u ) * ( LOG( z_mo /                  &
+                                                          surf%z0h(m) )        &
+                                         - psi_h( z_mo / ol_u )                &
+                                         + psi_h( surf%z0h(m) / ol_u )         &
+                                           )                                   &
+                                         / ( LOG( z_mo / surf%z0(m) )          &
+                                         - psi_m( z_mo / ol_u )                &
+                                         + psi_m( surf%z0(m) / ol_u )          &
+                                           )**2                                &
+                        + ( z_mo / ol_l ) * ( LOG( z_mo / surf%z0h(m) )        &
+                                         - psi_h( z_mo / ol_l )                &
+                                         + psi_h( surf%z0h(m) / ol_l )         &
+                                           )                                   &
+                                         / ( LOG( z_mo / surf%z0(m) )          &
+                                         - psi_m( z_mo / ol_l )                &
+                                         + psi_m( surf%z0(m) / ol_l )          &
+                                           )**2                                &
+                          ) / ( ol_u - ol_l )
              ELSE
-                !$OMP PARALLEL DO PRIVATE( k, z_mo )
-                !$ACC PARALLEL LOOP PRIVATE(k, z_mo) &
-                !$ACC PRESENT(surf, drho_air_zw)
-                DO  m = 1, surf%ns
-
-                   k   = surf%k(m)
-
-                   z_mo = surf%z_mo(m)
-
-                   surf%rib(m) = - g * z_mo * surf%shf(m) *                    &
-                                        drho_air_zw(k-1)            /          &
-                        ( surf%uvw_abs(m)**3 * surf%pt1(m) * kappa**2          &
-                           + 1.0E-20_wp )
-                ENDDO
+!
+!--             Calculate f = Ri - 1 /[...]^3 = 0
+                f = surf%rib(m) - ( z_mo / ol_m ) /                            &
+                                             ( LOG( z_mo / surf%z0(m) )        &
+                                         - psi_m( z_mo / ol_m )                &
+                                         + psi_m( surf%z0(m) / ol_m )          &
+                                             )**3
+
+!
+!--             Calculate df/dL
+                f_d_ol = ( - ( z_mo / ol_u ) / ( LOG( z_mo / surf%z0(m) )      &
+                                         - psi_m( z_mo / ol_u )                &
+                                         + psi_m( surf%z0(m) / ol_u )          &
+                                                  )**3                         &
+                           + ( z_mo / ol_l ) / ( LOG( z_mo / surf%z0(m) )      &
+                                         - psi_m( z_mo / ol_l )                &
+                                         + psi_m( surf%z0(m) / ol_l )          &
+                                            )**3                               &
+                          ) / ( ol_u - ol_l )
              ENDIF
-          ENDIF
-
-       ENDIF
-
-
-!
-!--    Calculate the Obukhov length either using a Newton iteration
-!--    method, via a lookup table, or using the old circular way
-       IF ( TRIM( most_method ) == 'newton' )  THEN
-
-          !$ACC PARALLEL LOOP PRIVATE(i, j, z_mo) &
-          !$ACC PRIVATE(ol_old, ol_m, ol_l, ol_u, f, f_d_ol) &
-          !$ACC PRESENT(surf)
-          DO  m = 1, surf%ns
-
-             i   = surf%i(m)            
-             j   = surf%j(m)
-
-             z_mo = surf%z_mo(m)
-
-!
-!--          Store current value in case the Newton iteration fails
-             ol_old = surf%ol(m)
+!
+!--          Calculate new L
+             surf%ol(m) = ol_m - f / f_d_ol
 
 !
 !--          Ensure that the bulk Richardson number and the Obukhov 
-!--          length have the same sign
-             IF ( surf%rib(m) * surf%ol(m) < 0.0_wp  .OR.                      &
-                  ABS( surf%ol(m) ) == ol_max )  THEN
-                IF ( surf%rib(m) > 1.0_wp ) surf%ol(m) =  0.01_wp
-                IF ( surf%rib(m) < 0.0_wp ) surf%ol(m) = -0.01_wp
+!--          length have the same sign and ensure convergence.
+             IF ( surf%ol(m) * ol_m < 0.0_wp )  surf%ol(m) = ol_m * 0.5_wp
+!
+!--          If unrealistic value occurs, set L to the maximum
+!--          value that is allowed
+             IF ( ABS( surf%ol(m) ) > ol_max )  THEN
+                surf%ol(m) = ol_max
+                EXIT
              ENDIF
 !
-!--          Iteration to find Obukhov length
-             iter = 0
-             DO
-                iter = iter + 1
-!
-!--             In case of divergence, use the value of the previous time step
-                IF ( iter > 1000 )  THEN
-                   surf%ol(m) = ol_old
-                   EXIT
-                ENDIF
-
-                ol_m = surf%ol(m)
-                ol_l = ol_m - 0.001_wp * ol_m
-                ol_u = ol_m + 0.001_wp * ol_m
-
-
-                IF ( ibc_pt_b /= 1 )  THEN
-!
-!--                Calculate f = Ri - [...]/[...]^2 = 0
-                   f = surf%rib(m) - ( z_mo / ol_m ) * (                       &
-                                                 LOG( z_mo / surf%z0h(m) )     &
-                                                 - psi_h( z_mo / ol_m )        &
-                                                 + psi_h( surf%z0h(m) /        &
-                                                          ol_m )               &
-                                                               )               &
-                                              / ( LOG( z_mo / surf%z0(m) )     &
-                                                 - psi_m( z_mo / ol_m )        &
-                                                 + psi_m( surf%z0(m) /         &
-                                                          ol_m )               &
-                                                 )**2
-
-!
-!--                 Calculate df/dL
-                    f_d_ol = ( - ( z_mo / ol_u ) * ( LOG( z_mo /               &
-                                                             surf%z0h(m) )     &
-                                            - psi_h( z_mo / ol_u )             &
-                                            + psi_h( surf%z0h(m) / ol_u )      &
-                                              )                                &
-                                            / ( LOG( z_mo / surf%z0(m) )       &
-                                            - psi_m( z_mo / ol_u )             &
-                                            + psi_m( surf%z0(m) / ol_u )       &
-                                              )**2                             &
-                           + ( z_mo / ol_l ) * ( LOG( z_mo / surf%z0h(m) )     &
-                                            - psi_h( z_mo / ol_l )             &
-                                            + psi_h( surf%z0h(m) / ol_l )      &
-                                              )                                &
-                                            / ( LOG( z_mo / surf%z0(m) )       &
-                                            - psi_m( z_mo / ol_l )             &
-                                            + psi_m( surf%z0(m) / ol_l )       &
-                                              )**2                             &
-                             ) / ( ol_u - ol_l )
-                ELSE
-!
-!--                Calculate f = Ri - 1 /[...]^3 = 0
-                   f = surf%rib(m) - ( z_mo / ol_m ) /                         &
-                                                ( LOG( z_mo / surf%z0(m) )     &
-                                            - psi_m( z_mo / ol_m )             &
-                                            + psi_m( surf%z0(m) / ol_m )       &
-                                                )**3
-
-!
-!--                Calculate df/dL
-                   f_d_ol = ( - ( z_mo / ol_u ) / ( LOG( z_mo /                &
-                                                            surf%z0(m) )       &
-                                            - psi_m( z_mo / ol_u )             &
-                                            + psi_m( surf%z0(m) / ol_u )       &
-                                                     )**3                      &
-                           + ( z_mo / ol_l ) / ( LOG( z_mo / surf%z0(m) )      &
-                                            - psi_m( z_mo / ol_l )             &
-                                            + psi_m( surf%z0(m) / ol_l )       &
-                                               )**3                            &
-                                  ) / ( ol_u - ol_l )
-                ENDIF
-!
-!--             Calculate new L
-                surf%ol(m) = ol_m - f / f_d_ol
-
-!
-!--             Ensure that the bulk Richardson number and the Obukhov 
-!--             length have the same sign and ensure convergence.
-                IF ( surf%ol(m) * ol_m < 0.0_wp )  surf%ol(m) = ol_m * 0.5_wp
-!
-!--             If unrealistic value occurs, set L to the maximum
-!--             value that is allowed
-                IF ( ABS( surf%ol(m) ) > ol_max )  THEN
-                   surf%ol(m) = ol_max
-                   EXIT
-                ENDIF
-!
-!--             Check for convergence
-                IF ( ABS( ( surf%ol(m) - ol_m ) /                              &
-                     surf%ol(m) ) < 1.0E-4_wp )  THEN
-                   EXIT
-                ELSE
-                   CYCLE
-                ENDIF
-
-             ENDDO
+!--          Check for convergence
+             IF ( ABS( ( surf%ol(m) - ol_m ) /  surf%ol(m) ) < 1.0E-4_wp )  THEN
+                EXIT
+             ELSE
+                CYCLE
+             ENDIF
+
           ENDDO
-
-       ELSEIF ( TRIM( most_method ) == 'lookup' )  THEN
-
-          !$OMP PARALLEL DO PRIVATE( i, j, z_mo, li ) FIRSTPRIVATE( li_bnd ) LASTPRIVATE( li_bnd )
-          DO  m = 1, surf%ns
-
-             i   = surf%i(m)            
-             j   = surf%j(m)
-!
-!--          If the bulk Richardson number is outside the range of the lookup
-!--          table, set it to the exceeding threshold value
-             IF ( surf%rib(m) < rib_min )  surf%rib(m) = rib_min
-             IF ( surf%rib(m) > rib_max )  surf%rib(m) = rib_max
-
-!
-!--          Find the correct index bounds for linear interpolation. As the
-!--          Richardson number will not differ very much from time step to
-!--          time step , use the index from the last step and search in the 
-!--          correct direction
-             li = li_bnd
-             IF ( rib_tab(li) - surf%rib(m) > 0.0_wp )  THEN
-                DO  WHILE ( rib_tab(li-1) - surf%rib(m) > 0.0_wp  .AND.  li > 0 )
-                   li = li-1
-                ENDDO
-             ELSE
-                DO  WHILE ( rib_tab(li) - surf%rib(m) < 0.0_wp                 &
-                           .AND.  li < num_steps-1 )
-                   li = li+1
-                ENDDO
-             ENDIF
-             li_bnd = li
-
-!
-!--          Linear interpolation to find the correct value of z/L
-             surf%ol(m) = ( ol_tab(li-1) + ( ol_tab(li) - ol_tab(li-1) )       &
-                         / (  rib_tab(li) - rib_tab(li-1) )                    &
-                         * ( surf%rib(m) - rib_tab(li-1) ) )
-
-          ENDDO
-
-       ELSEIF ( TRIM( most_method ) == 'circular' )  THEN
-
-          IF ( .NOT. humidity )  THEN
-             !$OMP PARALLEL DO PRIVATE( z_mo )
-             DO  m = 1, surf%ns
-
-                z_mo = surf%z_mo(m)
-
-                surf%ol(m) =  ( surf%pt1(m) *  surf%us(m)**2 ) /               &
-                                       ( kappa * g *                           &
-                                         surf%ts(m) + 1E-30_wp )
-!
-!--             Limit the value range of the Obukhov length.
-!--             This is necessary for very small velocities (u,v --> 1), because
-!--             the absolute value of ol can then become very small, which in
-!--             consequence would result in very large shear stresses and very
-!--             small momentum fluxes (both are generally unrealistic).
-                IF ( ( z_mo / ( surf%ol(m) + 1E-30_wp ) ) < zeta_min )         &
-                   surf%ol(m) = z_mo / zeta_min
-                IF ( ( z_mo / ( surf%ol(m) + 1E-30_wp ) ) > zeta_max )         &
-                   surf%ol(m) = z_mo / zeta_max
-
-             ENDDO
-          ELSEIF ( bulk_cloud_model  .OR.  cloud_droplets )  THEN
-             !$OMP PARALLEL DO PRIVATE( i, j, k, z_mo )
-             DO  m = 1, surf%ns
-
-                i   = surf%i(m)            
-                j   = surf%j(m)
-                k   = surf%k(m)
-
-                z_mo = surf%z_mo(m)
-
-
-                surf%ol(m) =  ( surf%vpt1(m) * surf%us(m)**2 ) /               &
-                    ( kappa * g * ( surf%ts(m) +                               &
-                         0.61_wp * surf%pt1(m) * surf%us(m)                    &
-                       + 0.61_wp * surf%qv1(m) * surf%ts(m) -                  &
-                                   surf%ts(m)  * ql(k,j,i) ) + 1E-30_wp )
-!
-!--             Limit the value range of the Obukhov length.
-!--             This is necessary for very small velocities (u,v --> 1), because
-!--             the absolute value of ol can then become very small, which in
-!--             consequence would result in very large shear stresses and very
-!--             small momentum fluxes (both are generally unrealistic).
-                IF ( ( z_mo / ( surf%ol(m) + 1E-30_wp ) ) < zeta_min )         &
-                   surf%ol(m) = z_mo / zeta_min
-                IF ( ( z_mo / ( surf%ol(m) + 1E-30_wp ) ) > zeta_max )         &
-                   surf%ol(m) = z_mo / zeta_max
-
-             ENDDO
-          ELSE
-
-             !$OMP PARALLEL DO PRIVATE( z_mo )
-             DO  m = 1, surf%ns
-
-                z_mo = surf%z_mo(m)
-
-                surf%ol(m) =  ( surf%vpt1(m) *  surf%us(m)**2 ) /              &
-                    ( kappa * g * ( surf%ts(m) + 0.61_wp * surf%pt1(m) *       &
-                                    surf%qs(m) + 0.61_wp * surf%qv1(m) *       &
-                                    surf%ts(m) ) + 1E-30_wp )
-
-!
-!--             Limit the value range of the Obukhov length.
-!--             This is necessary for very small velocities (u,v --> 1), because
-!--             the absolute value of ol can then become very small, which in
-!--             consequence would result in very large shear stresses and very
-!--             small momentum fluxes (both are generally unrealistic).
-                IF ( ( z_mo / ( surf%ol(m) + 1E-30_wp ) ) < zeta_min )         &
-                   surf%ol(m) = z_mo / zeta_min
-                IF ( ( z_mo / ( surf%ol(m) + 1E-30_wp ) ) > zeta_max )         &
-                   surf%ol(m) = z_mo / zeta_max
-
-             ENDDO
-
-          ENDIF
-
-       ENDIF
+       ENDDO
 
     END SUBROUTINE calc_ol
Index: /palm/trunk/SOURCE/write_restart_data_mod.f90
===================================================================
--- /palm/trunk/SOURCE/write_restart_data_mod.f90	(revision 3667)
+++ /palm/trunk/SOURCE/write_restart_data_mod.f90	(revision 3668)
@@ -163,5 +163,5 @@
 
 
-       binary_version_global = '4.7'
+       binary_version_global = '4.8'
 
        CALL wrd_write_string( 'binary_version_global' )
@@ -466,7 +466,4 @@
        WRITE ( 14 )  momentum_advec
 
-       CALL wrd_write_string( 'most_method' ) 
-       WRITE ( 14 )  most_method
-
        CALL wrd_write_string( 'netcdf_precision' ) 
        WRITE ( 14 )  netcdf_precision
